Attribute VB_Name = "HyperLinks"
Option Explicit

'I͈͂̃nCp[N폜
Sub DeleteHyperLinks()
    Dim link As Hyperlink
    For Each link In Application.Selection.HyperLinks
        link.Delete
    Next link
End Sub
'I͈͂́g؂ꂽhnCp[N폜
Sub DeleteHyperLinksIfDoesNotExist()
    Call DeleteHyperLinksIfDoesNotExistCore(Application.Selection)
End Sub
Sub DeleteHyperLinksIfDoesNotExistCore(range As range)
    Dim link As Hyperlink
    For Each link In range.HyperLinks
    If InStr(link.Address, ":") = 0 Then
        
        If Len(dir(ThisWorkbook.path + "\" + link.Address)) = 0 Then
            link.Delete
        End If
        
    End If
    Next link
End Sub

'I͈͂̃nCp[Ñt@CpXZ̒lɕύXitH_ړCnCp[NύXj
Sub ChangeFilePathsToValues()
    Call ChangeFileNamesToValuesCore(Application.Selection, True, False)
End Sub
'I͈͂̃nCp[Ñt@CZ̒lɕύXinCp[NύXj
Sub ChangeFileNamesToValues()
    Call ChangeFileNamesToValuesCore(Application.Selection, False, False)
End Sub
Sub ChangeFileNamesToValuesCore(range As range, changeDir As Boolean, changeExt As Boolean)
    Dim cell As range
    Dim link As Hyperlink
    Dim link_path, cell_path, ext, dir As String
    Dim dir_origin

    For Each cell In range
        If cell.value = "" Then
            Exit For
        End If
    For Each link In cell.HyperLinks
    If InStr(link.Address, ":") = 0 Then

        cell_path = CStr(cell.value)
        dir = DirPath(cell_path)
        ext = ExtensionInPath(cell_path)
        cell_path = Mid(cell_path, Len(dir) + 1, Len(cell_path) - Len(ext))

        link_path = link.Address
        If Not changeDir Then
            dir = DirPath(link_path)
        End If
        If Not changeExt Then
            ext = ExtensionInPath(link_path)
        End If

        cell_path = dir + cell_path + ext
        cell_path = CFilePath(CStr(cell_path))

        Call MoveFile( _
            ThisWorkbook.path + "\" + link_path, _
            ThisWorkbook.path + "\" + cell_path)

        link.Address = cell_path

    End If
    Next link
    Next cell
End Sub

'I͈͂̒lnCp[ÑpXɕύX
Sub ChangeValuesToHyperLinks()
    Dim cell As range
    Dim link As Hyperlink
    For Each cell In Application.Selection
        If cell.value = "" Then
            Exit For
        End If
    For Each link In cell.HyperLinks

        cell.value = link.Address

    Next link
    Next cell
End Sub

'I͈͂̒l݂t@C̃pẌꕔł΁CYt@C̃pX̒lɕύX
Sub ChangeValuesToExistingPath()
    Dim cell As range
    Dim fl, dr As Object
    Dim link_exists As Boolean
    Dim index, length, cost As Integer
    Dim name As String

    With CreateObject("Scripting.FileSystemObject")
        For Each cell In Application.Selection
            If cell.value = "" Then
                Exit For
            End If
        If cell.HyperLinks.count = 0 Then
        cost = 1024

        For Each dr In .GetFolder(ThisWorkbook.path + "\").SubFolders
        For Each fl In dr.files
        If InStr(fl.path, "__") = 0 Then

            name = fl.name
            length = Len(name)
            index = InStr(CFileName(name, -1), CFileName(cell.value))
            If 0 < index And length + index < cost Then
                cost = length + index
                name = Replace(fl.path, ThisWorkbook.path + "\", "")
                cell.value = name
            End If

        End If
        Next fl
        Next dr
        
        End If
        Next cell
    End With
End Sub
'I͈͂̒l݂t@C̃pXł΁CnCp[N쐬
Sub CreateHyperLinksAsValues()
    Call CreateHyperLinksAsValuesCore(Application.Selection)
End Sub
Sub CreateHyperLinksAsValuesCore(range As range)
    Dim cell As range
    Dim path As String
    For Each cell In range
        path = CFilePath(CStr(cell.value))
        If InStr(path, ":") = 0 And Len(dir(ThisWorkbook.path + "\" + path)) = 0 Then
            path = ""
        End If
        If Len(path) > 0 Then
            Call cell.HyperLinks.Add(cell, path)
        End If
    Next cell
End Sub

'[NubN݂̑tH_̃TutH_̃t@C̃Xg擾
Sub CreateFileList()
    Dim cell As range
    Dim fl, dr As Object
    Dim path As String
With CreateObject("Scripting.FileSystemObject")

    Set cell = Application.Selection(1)
    For Each dr In .GetFolder(ThisWorkbook.path + "\").SubFolders
    For Each fl In dr.files
    If InStr(fl.path, "__") = 0 Then

        
        path = Replace(fl.path, ThisWorkbook.path + "\", "")
        cell.value = path
        Call cell.HyperLinks.Add(cell, path)
        Set cell = cell.Offset(1, 0)

    End If
    Next fl
    Next dr

End With
End Sub

'nCp[ÑׂZɈړ
Sub CopyHyperLinksToLeftCell()
    Dim cell, target As range
    Dim link As Hyperlink
    For Each cell In Application.Selection
    For Each link In cell.HyperLinks
        If cell.Column = 1 Then
            link.Delete
            Exit For
        End If

        Set target = cell.Offset(0, -1)
        Call target.HyperLinks.Add(target, link.Address)

        link.Delete

    Next link
    Next cell
End Sub

'I͈͂̒l̃pXeLXgt@C̍쐬
Sub MakeTextFile()
    Dim cell As range
    Dim path As String
With CreateObject("Scripting.FileSystemObject")
    For Each cell In Application.Selection
    If cell.value <> "" And cell.HyperLinks.count = 0 Then
        path = CFilePath(cell.value)
        Call CreateFile(ThisWorkbook.path + "\" + path)
        Call cell.HyperLinks.Add(cell, path)
    End If
    Next cell
End With
End Sub





