Attribute VB_Name = "Reference"
Option Explicit
Const ForReading = 1
Const AddCompletePath = "__add-complete"
Const AddFilePath = "__new"
Const NewFilePath = "new"
Const ImportExtension = ".enw"

'VKXgɒǉ
Sub AddNewList()
Dim new_sheet, list_sheet As Worksheet
Dim edit_range As range
    Set list_sheet = ActiveSheet
    If list_sheet.AutoFilter Is Nothing Then
        MsgBox ("tB^KpĂ܂")
        Exit Sub
    End If

    Set new_sheet = NewFilesOnSheet()
    If new_sheet Is Nothing Then
        MsgBox ("ǉt@C݂܂")
        Exit Sub
    End If

    Set edit_range = MergeTable(new_sheet.UsedRange, list_sheet.AutoFilter.range)
    Call edit_range.AutoFilter
    Call edit_range.AutoFilter

Call new_sheet.Delete
End Sub


Function MergeTable(source As range, target As range) As range
    Dim r, c, ct, add_column As Long
    Dim target_labels, target_indexes, source_records As range

    add_column = 0
    Call source.Resize(1, source.Columns.count).Insert(xlDown)
    Call source.Resize(1, source.Columns.count).Insert(xlDown)
    
    Set target_labels = source.Offset(-2, 0).Resize(1, target.Columns.count)
    Set target_indexes = source.Offset(-1, 0).Resize(1, source.Columns.count)
    target_labels.value = target.Resize(1, target.Columns.count).value

    For c = 1 To source.Columns.count
    For ct = 1 To target_labels.Columns.count
        If source(1, c).value = "" Then
            Exit For
        ElseIf source(1, c).value = target_labels(1, ct).value Then
            target_indexes(1, c).value = ct - 1
            target_labels(1, ct).value = ""
            Exit For
        End If
    Next ct
    If source(1, c).value <> "" And target_indexes(1, c).value = "" Then
        add_column = add_column + 1
        target_indexes(1, c).value = target_labels.Columns.count + add_column - 1
        target.Offset(0, target_indexes(1, c).value) _
            .Resize(1, 1).value = source(1, c).value
    End If
    Next c

    Set source_records = source.Offset(1).Resize(source.Rows.count - 1, source.Columns.count)
    For r = 1 To source_records.Rows.count
    For c = 1 To source_records.Columns.count
    If target_indexes(1, c).value <> "" Then
        target.Offset(target.Rows.count + r - 1, target_indexes(1, c).value) _
            .Resize(1, 1).value = source_records(r, c).value
    End If
    Next c
    Next r
    Call CreateHyperLinksAsValuesCore(target _
        .Offset(target.Rows.count) _
        .Resize(source_records.Rows.count, _
            target.Columns.count + add_column))
    Set MergeTable = target.Resize( _
        target.Rows.count + source_records.Rows.count, _
        target.Columns.count + add_column)
End Function


Function NewFilesOnSheet() As Worksheet
    Dim dir, file, f, r, lines, line
    Dim label As String, value As String
    Dim txt As String, pdf As String, doc As String
    Dim sheet As Worksheet
    Set sheet = ThisWorkbook.Sheets.Add(after:=ActiveSheet)
    Set NewFilesOnSheet = sheet
    sheet.name = Replace(sheet.name, "Sheet", "NewList")
With CreateObject("Scripting.FileSystemObject")
    Set dir = .GetFolder(ThisWorkbook.path + "\" + AddFilePath)
    r = 2
    For Each file In dir.files
    If ExtensionInPath(file.path) = ImportExtension Then

        txt = ""
        pdf = ""
        doc = ""
        For Each f In dir.files
        If Replace(file.path, ImportExtension, ".txt") = f.path Then
            txt = f.path
        ElseIf Replace(file.path, ImportExtension, ".pdf") = f.path Then
            pdf = f.path
        ElseIf Replace(file.path, ImportExtension, ".doc") = f.path _
            Or Replace(file.path, ImportExtension, ".docx") = f.path Then
            doc = f.path
        End If
        Next f

        If txt <> "" Then
            txt = SetFile(txt)
            Call SetColumnAndValue(sheet, r, "Text", txt)
        End If
        If pdf <> "" Then
            pdf = SetFile(pdf)
            Call SetColumnAndValue(sheet, r, "PDF", pdf)
        End If
        If doc <> "" Then
            doc = SetFile(doc)
            Call SetColumnAndValue(sheet, r, "Document", doc)
        End If

        lines = LoadTextLines(file.path)
        For Each line In lines
            label = GetEnfLabel(CStr(line))
            value = GetEnfValue(CStr(line))
            
            Call SetColumnAndValue(sheet, r, label, value)
        Next line
    r = r + 1
    End If
    Next file

    Call CreateHyperLinksAsValuesCore(sheet.UsedRange)
    Call MoveDir(dir.path, ThisWorkbook.path + "\" + AddCompletePath _
        + "\" + Replace(CFilePath(CStr(Now)), "\", "-"))

    Call CreateDir(ThisWorkbook.path + "\" + AddFilePath)

End With
End Function
Sub SetColumnAndValue(sheet As Worksheet, r, label As String, value As String)
    Dim c
If label = "" Then
Exit Sub
End If
    c = 1
    Do While sheet.Cells(1, c).value <> ""
    If sheet.Cells(1, c).value = label And sheet.Cells(r, c).value = "" Then
        sheet.Cells(r, c).value = value
        Exit Sub
    End If
    c = c + 1
    Loop
        sheet.Cells(1, c).value = label
        sheet.Cells(r, c).value = value
End Sub
Function SetFile(path As String) As String
Dim dir As String
    dir = DirPath(path)
    SetFile = Replace(dir, _
        ThisWorkbook.path + "\" + AddFilePath, _
        ThisWorkbook.path + "\" + NewFilePath) _
        + CFileName(Mid(path, Len(dir) + 1))
    Call MoveFile(path, SetFile)
    SetFile = Replace(SetFile, ThisWorkbook.path + "\", "")
End Function

Function GetEnfLabel(line As String) As String
If Len(line) < 2 Then
GetEnfLabel = ""
Exit Function
End If
    GetEnfLabel = Left(line, 2)
    GetEnfLabel = Replace(GetEnfLabel, "TY", "TYPE")
    GetEnfLabel = Replace(GetEnfLabel, "%0", "TYPE")
    GetEnfLabel = Replace(GetEnfLabel, "AU", "")
    GetEnfLabel = Replace(GetEnfLabel, "%A", "")
    GetEnfLabel = Replace(GetEnfLabel, "TI", "^Cg")
    GetEnfLabel = Replace(GetEnfLabel, "%T", "^Cg")
    GetEnfLabel = Replace(GetEnfLabel, "T2", "oW")
    GetEnfLabel = Replace(GetEnfLabel, "%J", "oW")
    GetEnfLabel = Replace(GetEnfLabel, "%I", "oW")
    GetEnfLabel = Replace(GetEnfLabel, "%B", "oW")
    GetEnfLabel = Replace(GetEnfLabel, "SN", "ID")
    GetEnfLabel = Replace(GetEnfLabel, "%@", "ID")
    GetEnfLabel = Replace(GetEnfLabel, "PY", "N")
    GetEnfLabel = Replace(GetEnfLabel, "%D", "N")
    GetEnfLabel = Replace(GetEnfLabel, "DA", "t")
    GetEnfLabel = Replace(GetEnfLabel, "VL", "Vol.")
    GetEnfLabel = Replace(GetEnfLabel, "%V", "Vol.")
    GetEnfLabel = Replace(GetEnfLabel, "IS", "No.")
    GetEnfLabel = Replace(GetEnfLabel, "%N", "No.")
    GetEnfLabel = Replace(GetEnfLabel, "SP", "page")
    GetEnfLabel = Replace(GetEnfLabel, "%P", "page")
    GetEnfLabel = Replace(GetEnfLabel, "UR", "URL")
End Function
Function GetEnfValue(line As String) As String
    Dim header As String
    Dim a, is_en As Boolean
If Len(line) < 2 Then
GetEnfValue = ""
Exit Function
End If
    header = Left(line, 1)
    GetEnfValue = Mid(line, 4)
    a = MatchCount(GetEnfValue, "[a-zA-Z ]")
    is_en = MatchCount(GetEnfValue, "[a-zA-Z ]") > Len(GetEnfValue) / 2
    If header = "%" Then
        If Left(line, 2) = "%@" Then
            GetEnfValue = Replace(GetEnfValue, "-", "")
        End If
    Else
        GetEnfValue = Mid(GetEnfValue, 4)

        If Left(line, 2) = "TY" Then
            GetEnfValue = Replace(GetEnfValue, "JOUR", "Journal Article")
        End If
        If Left(line, 2) = "AU" And Not is_en Then
            GetEnfValue = Replace(GetEnfValue, ", ", "")
        End If
    End If
    
    GetEnfValue = Replace(GetEnfValue, " =", "=")
    GetEnfValue = Replace(GetEnfValue, " ?", "?")
    GetEnfValue = Replace(GetEnfValue, " !", "!")
    GetEnfValue = Replace(GetEnfValue, " ;", ";")
    GetEnfValue = Replace(GetEnfValue, " :", ":")
    GetEnfValue = Replace(GetEnfValue, " (", "(")
    GetEnfValue = Replace(GetEnfValue, ") ", ")")
    GetEnfValue = Replace(GetEnfValue, " """, """")
    GetEnfValue = Replace(GetEnfValue, """ ", """")
    GetEnfValue = Replace(GetEnfValue, "E", " ")

End Function


